//

import java.io.*;
import java.lang.*;
import java.util.*;
import java.lang.reflect.*;
import java_cup.runtime.Symbol;

public class scanner implements java_cup.runtime.Scanner {
    private LineNumberReader lnr = null;
    private Class            symClass = null;
    private StringTokenizer  st = null;
    public  int              verbose = 0;

    public scanner( String fileName ) throws java.io.IOException { 
	lnr  =  new LineNumberReader( new FileReader( fileName ) ); 
	if( verbose > 0 ) System.out.println( "File " + fileName + " opened");
	symClass = (new sym() ).getClass();
	if( verbose > 0 ) {
	    Field[] f = symClass.getFields();
	    for( int i=0; i<f.length; i++ ) {
		System.out.println( f[i] );
	    }
	}
    }

    /* single lookahead character */
    protected int next_char;
    
    /* advance input by one character */
    protected void advance() throws java.io.IOException
    { }

    /* initialize the scanner */
    private void init() throws java.io.IOException
    { 
	advance(); 
    }


    /* recognize and return the next complete token */
    public Symbol next_token() throws Exception {
      
	if( st == null || (! st.hasMoreTokens() ) ) {
	    String line = lnr.readLine();
	    if( line == null ) return new Symbol( sym.MYEOF );
	    line = line.trim();
	    if( verbose > 0 ) System.out.println( "line: " + line );
	    st = new StringTokenizer( line );
	}

	String token = st.nextToken();
	System.out.println( "token: " + token );
	//System.out.println( symClass.getField( line.toUpperCase() ) );
	//System.out.println( (symClass.getField( line.toUpperCase()).getInt(null) ) );
	return new Symbol( (symClass.getField( token.toUpperCase()).getInt(null) ), token );

    }

    public static void main( String[] args ) throws Exception {
        System.out.println( "SCANNER TEST");
	scanner sc = new scanner( "test.txt" );
	sc.init();
	Symbol res;
	while( (res=sc.next_token() ) != null ) {
	}
      }


};
